<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'OTA_CancelRQ' => '\\StructType\\OTA_CancelRQ',
            'POS' => '\\StructType\\POS',
            'Source' => '\\StructType\\Source',
            'BookingChannel' => '\\StructType\\BookingChannel',
            'CompanyName' => '\\StructType\\CompanyName',
            'RequestorID' => '\\StructType\\RequestorID',
            'UniqueID' => '\\StructType\\UniqueID',
            'Verification' => '\\StructType\\Verification',
            'PersonName' => '\\StructType\\PersonName',
            'ReservationTimeSpan' => '\\StructType\\ReservationTimeSpan',
            'Vendor' => '\\StructType\\Vendor',
            'OTA_CancelRS' => '\\StructType\\OTA_CancelRS',
            'CancelInfoRS' => '\\StructType\\CancelInfoRS',
            'Errors' => '\\StructType\\Errors',
            'Warnings' => '\\StructType\\Warnings',
            'Error' => '\\StructType\\Error',
            'Success' => '\\StructType\\Success',
            'Warning' => '\\StructType\\Warning',
            'OTA_PingRS' => '\\StructType\\OTA_PingRS',
            'OTA_HotelResRQ' => '\\StructType\\OTA_HotelResRQ',
            'HotelReservations' => '\\StructType\\HotelReservations',
            'HotelReservation' => '\\StructType\\HotelReservation',
            'RoomStays' => '\\StructType\\RoomStays',
            'ResGuests' => '\\StructType\\ResGuests',
            'RoomStay' => '\\StructType\\RoomStay',
            'RoomTypes' => '\\StructType\\RoomTypes',
            'RoomRates' => '\\StructType\\RoomRates',
            'ResGuestRPHs' => '\\StructType\\ResGuestRPHs',
            'RatePlans' => '\\StructType\\RatePlans',
            'SpecialRequests' => '\\StructType\\SpecialRequests',
            'CancelPenalties' => '\\StructType\\CancelPenalties',
            'Comments' => '\\StructType\\Comments',
            'RoomType' => '\\StructType\\RoomType',
            'AdditionalDetails' => '\\StructType\\AdditionalDetails',
            'Amenities' => '\\StructType\\Amenities',
            'AdditionalDetail' => '\\StructType\\AdditionalDetail',
            'DetailDescription' => '\\StructType\\DetailDescription',
            'Amenity' => '\\StructType\\Amenity',
            'RoomDescription' => '\\StructType\\RoomDescription',
            'RoomRate' => '\\StructType\\RoomRate',
            'Features' => '\\StructType\\Features',
            'Feature' => '\\StructType\\Feature',
            'Description' => '\\StructType\\Description',
            'Rates' => '\\StructType\\Rates',
            'Rate' => '\\StructType\\Rate',
            'AdditionalGuestAmounts' => '\\StructType\\AdditionalGuestAmounts',
            'TPA_Extensions' => '\\StructType\\TPA_Extensions',
            'AdditionalGuestAmount' => '\\StructType\\AdditionalGuestAmount',
            'Amount' => '\\StructType\\Amount',
            'Base' => '\\StructType\\Base',
            'Taxes' => '\\StructType\\Taxes',
            'Tax' => '\\StructType\\Tax',
            'Fees' => '\\StructType\\Fees',
            'Fee' => '\\StructType\\Fee',
            'PaymentPolicies' => '\\StructType\\PaymentPolicies',
            'RequiredPayment' => '\\StructType\\RequiredPayment',
            'AcceptedPayment' => '\\StructType\\AcceptedPayment',
            'PaymentCard' => '\\StructType\\PaymentCard',
            'Address' => '\\StructType\\Address',
            'CountryName' => '\\StructType\\CountryName',
            'StateProv' => '\\StructType\\StateProv',
            'Telephone' => '\\StructType\\Telephone',
            'Total' => '\\StructType\\Total',
            'TpaExtension' => '\\StructType\\TpaExtension',
            'Extension' => '\\StructType\\Extension',
            'GuestCounts' => '\\StructType\\GuestCounts',
            'GuestCount' => '\\StructType\\GuestCount',
            'TimeSpan' => '\\StructType\\TimeSpan',
            'Guarantee' => '\\StructType\\Guarantee',
            'GuaranteesAccepted' => '\\StructType\\GuaranteesAccepted',
            'GuaranteeAccepted' => '\\StructType\\GuaranteeAccepted',
            'DirectBill' => '\\StructType\\DirectBill',
            'BasicPropertyInfo' => '\\StructType\\BasicPropertyInfo',
            'ContactNumbers' => '\\StructType\\ContactNumbers',
            'VendorMessages' => '\\StructType\\VendorMessages',
            'Award' => '\\StructType\\Award',
            'ContactNumber' => '\\StructType\\ContactNumber',
            'VendorMessage' => '\\StructType\\VendorMessage',
            'SubSection' => '\\StructType\\SubSection',
            'Paragraph' => '\\StructType\\Paragraph',
            'ResGuestRPH' => '\\StructType\\ResGuestRPH',
            'RatePlan' => '\\StructType\\RatePlan',
            'CancelPenalty' => '\\StructType\\CancelPenalty',
            'AmountPercent' => '\\StructType\\AmountPercent',
            'Deadline' => '\\StructType\\Deadline',
            'PenaltyDescription' => '\\StructType\\PenaltyDescription',
            'RatePlanDescription' => '\\StructType\\RatePlanDescription',
            'MealsIncluded' => '\\StructType\\MealsIncluded',
            'SpecialRequest' => '\\StructType\\SpecialRequest',
            'Comment' => '\\StructType\\Comment',
            'ResGuest' => '\\StructType\\ResGuest',
            'Profiles' => '\\StructType\\Profiles',
            'ProfileInfo' => '\\StructType\\ProfileInfo',
            'Profile' => '\\StructType\\Profile',
            'Affiliations' => '\\StructType\\Affiliations',
            'Customer' => '\\StructType\\Customer',
            'Primary' => '\\StructType\\Primary',
            'Document' => '\\StructType\\Document',
            'PaymentForm' => '\\StructType\\PaymentForm',
            'Organization' => '\\StructType\\Organization',
            'OrgName' => '\\StructType\\OrgName',
            'ResGlobalInfo' => '\\StructType\\ResGlobalInfo',
            'HotelReservationIDs' => '\\StructType\\HotelReservationIDs',
            'HotelReservationID' => '\\StructType\\HotelReservationID',
            'OTA_HotelResRS' => '\\StructType\\OTA_HotelResRS',
            'OTA_ErrorRS' => '\\StructType\\OTA_ErrorRS',
            'OTA_ReadRQ' => '\\StructType\\OTA_ReadRQ',
            'ReadRequests' => '\\StructType\\ReadRequests',
            'ReadRequest' => '\\StructType\\ReadRequest',
            'OTA_ResRetrieveRS' => '\\StructType\\OTA_ResRetrieveRS',
            'PackageReservation' => '\\StructType\\PackageReservation',
            'PassengerListItems' => '\\StructType\\PassengerListItems',
            'Transactions' => '\\StructType\\Transactions',
            'InvoiceDetail' => '\\StructType\\InvoiceDetail',
            'BalanceDueAmount' => '\\StructType\\BalanceDueAmount',
            'PassengerListItem' => '\\StructType\\PassengerListItem',
            'SpecialNeed' => '\\StructType\\SpecialNeed',
            'Package' => '\\StructType\\Package',
            'Cautions' => '\\StructType\\Cautions',
            'ItineraryItems' => '\\StructType\\ItineraryItems',
            'ItineraryItem' => '\\StructType\\ItineraryItem',
            'Accommodation' => '\\StructType\\Accommodation',
            'RoomProfiles' => '\\StructType\\RoomProfiles',
            'RoomProfile' => '\\StructType\\RoomProfile',
            'PassengerRPHs' => '\\StructType\\PassengerRPHs',
            'SupplementCharges' => '\\StructType\\SupplementCharges',
            'Charge' => '\\StructType\\Charge',
            'Flights' => '\\StructType\\Flights',
            'Flight' => '\\StructType\\Flight',
            'ArrivalAirport' => '\\StructType\\ArrivalAirport',
            'DepartureAirport' => '\\StructType\\DepartureAirport',
            'Equipment' => '\\StructType\\Equipment',
            'RentalCar' => '\\StructType\\RentalCar',
            'PickUpLocation' => '\\StructType\\PickUpLocation',
            'ReturnLocation' => '\\StructType\\ReturnLocation',
            'PriceInfo' => '\\StructType\\PriceInfo',
            'Transaction' => '\\StructType\\Transaction',
            'OTA_HotelAvailRQ' => '\\StructType\\OTA_HotelAvailRQ',
            'AvailRequestSegments' => '\\StructType\\AvailRequestSegments',
            'AvailRequestSegment' => '\\StructType\\AvailRequestSegment',
            'RatePlanCandidates' => '\\StructType\\RatePlanCandidates',
            'RoomStayCandidates' => '\\StructType\\RoomStayCandidates',
            'HotelSearchCriteria' => '\\StructType\\HotelSearchCriteria',
            'RatePlanCandidate' => '\\StructType\\RatePlanCandidate',
            'HotelRefs' => '\\StructType\\HotelRefs',
            'HotelRef' => '\\StructType\\HotelRef',
            'RoomStayCandidate' => '\\StructType\\RoomStayCandidate',
            'Criterion' => '\\StructType\\Criterion',
            'PackageRefs' => '\\StructType\\PackageRefs',
            'PackageRef' => '\\StructType\\PackageRef',
            'OTA_HotelAvailRS' => '\\StructType\\OTA_HotelAvailRS',
            'Criteria' => '\\StructType\\Criteria',
            'pingRequest' => '\\StructType\\PingRequest',
            'discount' => '\\StructType\\Discount',
            'acceptedPayments' => '\\StructType\\AcceptedPayments',
            'customerLoyaltyProgram' => '\\StructType\\CustomerLoyaltyProgram',
            'DepositPayments' => '\\StructType\\DepositPayments',
            'abstractCollection' => '\\StructType\\AbstractCollection',
            'abstractSet' => '\\StructType\\AbstractSet',
            'hashSet' => '\\StructType\\HashSet',
            'linkedHashSet' => '\\StructType\\LinkedHashSet',
            'reservationList' => '\\StructType\\ReservationList',
            'Name' => '\\StructType\\Name',
            'DateRange' => '\\StructType\\DateRange',
            'Identity' => '\\StructType\\Identity',
            'PassengerRPH' => '\\StructType\\PassengerRPH',
            'operatingAirline' => '\\StructType\\OperatingAirline',
            'travel' => '\\StructType\\Travel',
            'StayDateRange' => '\\StructType\\StayDateRange',
            'rateRange' => '\\StructType\\RateRange',
        );
    }
}
