<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AdditionalDetails StructType
 * @subpackage Structs
 */
class AdditionalDetails extends AbstractStructBase
{
    /**
     * The AdditionalDetail
     * Meta information extracted from the WSDL
     * - form: qualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\AdditionalDetail[]
     */
    public $AdditionalDetail;
    /**
     * Constructor method for AdditionalDetails
     * @uses AdditionalDetails::setAdditionalDetail()
     * @param \StructType\AdditionalDetail[] $additionalDetail
     */
    public function __construct(array $additionalDetail = array())
    {
        $this
            ->setAdditionalDetail($additionalDetail);
    }
    /**
     * Get AdditionalDetail value
     * @return \StructType\AdditionalDetail[]|null
     */
    public function getAdditionalDetail()
    {
        return $this->AdditionalDetail;
    }
    /**
     * This method is responsible for validating the values passed to the setAdditionalDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdditionalDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdditionalDetailForArrayConstraintsFromSetAdditionalDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $additionalDetailsAdditionalDetailItem) {
            // validation for constraint: itemType
            if (!$additionalDetailsAdditionalDetailItem instanceof \StructType\AdditionalDetail) {
                $invalidValues[] = is_object($additionalDetailsAdditionalDetailItem) ? get_class($additionalDetailsAdditionalDetailItem) : sprintf('%s(%s)', gettype($additionalDetailsAdditionalDetailItem), var_export($additionalDetailsAdditionalDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdditionalDetail property can only contain items of type \StructType\AdditionalDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdditionalDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\AdditionalDetail[] $additionalDetail
     * @return \StructType\AdditionalDetails
     */
    public function setAdditionalDetail(array $additionalDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($additionalDetailArrayErrorMessage = self::validateAdditionalDetailForArrayConstraintsFromSetAdditionalDetail($additionalDetail))) {
            throw new \InvalidArgumentException($additionalDetailArrayErrorMessage, __LINE__);
        }
        $this->AdditionalDetail = $additionalDetail;
        return $this;
    }
    /**
     * Add item to AdditionalDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\AdditionalDetail $item
     * @return \StructType\AdditionalDetails
     */
    public function addToAdditionalDetail(\StructType\AdditionalDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AdditionalDetail) {
            throw new \InvalidArgumentException(sprintf('The AdditionalDetail property can only contain items of type \StructType\AdditionalDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdditionalDetail[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AdditionalDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
