<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AvailRequestSegments StructType
 * @subpackage Structs
 */
class AvailRequestSegments extends AbstractStructBase
{
    /**
     * The AvailRequestSegment
     * Meta information extracted from the WSDL
     * - form: qualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\AvailRequestSegment[]
     */
    public $AvailRequestSegment;
    /**
     * Constructor method for AvailRequestSegments
     * @uses AvailRequestSegments::setAvailRequestSegment()
     * @param \StructType\AvailRequestSegment[] $availRequestSegment
     */
    public function __construct(array $availRequestSegment = array())
    {
        $this
            ->setAvailRequestSegment($availRequestSegment);
    }
    /**
     * Get AvailRequestSegment value
     * @return \StructType\AvailRequestSegment[]|null
     */
    public function getAvailRequestSegment()
    {
        return $this->AvailRequestSegment;
    }
    /**
     * This method is responsible for validating the values passed to the setAvailRequestSegment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAvailRequestSegment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAvailRequestSegmentForArrayConstraintsFromSetAvailRequestSegment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $availRequestSegmentsAvailRequestSegmentItem) {
            // validation for constraint: itemType
            if (!$availRequestSegmentsAvailRequestSegmentItem instanceof \StructType\AvailRequestSegment) {
                $invalidValues[] = is_object($availRequestSegmentsAvailRequestSegmentItem) ? get_class($availRequestSegmentsAvailRequestSegmentItem) : sprintf('%s(%s)', gettype($availRequestSegmentsAvailRequestSegmentItem), var_export($availRequestSegmentsAvailRequestSegmentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AvailRequestSegment property can only contain items of type \StructType\AvailRequestSegment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AvailRequestSegment value
     * @throws \InvalidArgumentException
     * @param \StructType\AvailRequestSegment[] $availRequestSegment
     * @return \StructType\AvailRequestSegments
     */
    public function setAvailRequestSegment(array $availRequestSegment = array())
    {
        // validation for constraint: array
        if ('' !== ($availRequestSegmentArrayErrorMessage = self::validateAvailRequestSegmentForArrayConstraintsFromSetAvailRequestSegment($availRequestSegment))) {
            throw new \InvalidArgumentException($availRequestSegmentArrayErrorMessage, __LINE__);
        }
        $this->AvailRequestSegment = $availRequestSegment;
        return $this;
    }
    /**
     * Add item to AvailRequestSegment value
     * @throws \InvalidArgumentException
     * @param \StructType\AvailRequestSegment $item
     * @return \StructType\AvailRequestSegments
     */
    public function addToAvailRequestSegment(\StructType\AvailRequestSegment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AvailRequestSegment) {
            throw new \InvalidArgumentException(sprintf('The AvailRequestSegment property can only contain items of type \StructType\AvailRequestSegment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AvailRequestSegment[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AvailRequestSegments
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
