<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CancelPenalties StructType
 * @subpackage Structs
 */
class CancelPenalties extends AbstractStructBase
{
    /**
     * The CancelPenalty
     * Meta information extracted from the WSDL
     * - form: qualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CancelPenalty[]
     */
    public $CancelPenalty;
    /**
     * Constructor method for CancelPenalties
     * @uses CancelPenalties::setCancelPenalty()
     * @param \StructType\CancelPenalty[] $cancelPenalty
     */
    public function __construct(array $cancelPenalty = array())
    {
        $this
            ->setCancelPenalty($cancelPenalty);
    }
    /**
     * Get CancelPenalty value
     * @return \StructType\CancelPenalty[]|null
     */
    public function getCancelPenalty()
    {
        return $this->CancelPenalty;
    }
    /**
     * This method is responsible for validating the values passed to the setCancelPenalty method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCancelPenalty method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCancelPenaltyForArrayConstraintsFromSetCancelPenalty(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $cancelPenaltiesCancelPenaltyItem) {
            // validation for constraint: itemType
            if (!$cancelPenaltiesCancelPenaltyItem instanceof \StructType\CancelPenalty) {
                $invalidValues[] = is_object($cancelPenaltiesCancelPenaltyItem) ? get_class($cancelPenaltiesCancelPenaltyItem) : sprintf('%s(%s)', gettype($cancelPenaltiesCancelPenaltyItem), var_export($cancelPenaltiesCancelPenaltyItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CancelPenalty property can only contain items of type \StructType\CancelPenalty, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CancelPenalty value
     * @throws \InvalidArgumentException
     * @param \StructType\CancelPenalty[] $cancelPenalty
     * @return \StructType\CancelPenalties
     */
    public function setCancelPenalty(array $cancelPenalty = array())
    {
        // validation for constraint: array
        if ('' !== ($cancelPenaltyArrayErrorMessage = self::validateCancelPenaltyForArrayConstraintsFromSetCancelPenalty($cancelPenalty))) {
            throw new \InvalidArgumentException($cancelPenaltyArrayErrorMessage, __LINE__);
        }
        $this->CancelPenalty = $cancelPenalty;
        return $this;
    }
    /**
     * Add item to CancelPenalty value
     * @throws \InvalidArgumentException
     * @param \StructType\CancelPenalty $item
     * @return \StructType\CancelPenalties
     */
    public function addToCancelPenalty(\StructType\CancelPenalty $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CancelPenalty) {
            throw new \InvalidArgumentException(sprintf('The CancelPenalty property can only contain items of type \StructType\CancelPenalty, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CancelPenalty[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CancelPenalties
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
