<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GuaranteeAccepted StructType
 * @subpackage Structs
 */
class GuaranteeAccepted extends AbstractStructBase
{
    /**
     * The DirectBill
     * Meta information extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * @var \StructType\DirectBill
     */
    public $DirectBill;
    /**
     * The PaymentCard
     * Meta information extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * @var \StructType\PaymentCard
     */
    public $PaymentCard;
    /**
     * The Default
     * @var bool
     */
    public $Default;
    /**
     * Constructor method for GuaranteeAccepted
     * @uses GuaranteeAccepted::setDirectBill()
     * @uses GuaranteeAccepted::setPaymentCard()
     * @uses GuaranteeAccepted::setDefault()
     * @param \StructType\DirectBill $directBill
     * @param \StructType\PaymentCard $paymentCard
     * @param bool $default
     */
    public function __construct(\StructType\DirectBill $directBill = null, \StructType\PaymentCard $paymentCard = null, $default = null)
    {
        $this
            ->setDirectBill($directBill)
            ->setPaymentCard($paymentCard)
            ->setDefault($default);
    }
    /**
     * Get DirectBill value
     * @return \StructType\DirectBill|null
     */
    public function getDirectBill()
    {
        return $this->DirectBill;
    }
    /**
     * Set DirectBill value
     * @param \StructType\DirectBill $directBill
     * @return \StructType\GuaranteeAccepted
     */
    public function setDirectBill(\StructType\DirectBill $directBill = null)
    {
        $this->DirectBill = $directBill;
        return $this;
    }
    /**
     * Get PaymentCard value
     * @return \StructType\PaymentCard|null
     */
    public function getPaymentCard()
    {
        return $this->PaymentCard;
    }
    /**
     * Set PaymentCard value
     * @param \StructType\PaymentCard $paymentCard
     * @return \StructType\GuaranteeAccepted
     */
    public function setPaymentCard(\StructType\PaymentCard $paymentCard = null)
    {
        $this->PaymentCard = $paymentCard;
        return $this;
    }
    /**
     * Get Default value
     * @return bool|null
     */
    public function getDefault()
    {
        return $this->Default;
    }
    /**
     * Set Default value
     * @param bool $default
     * @return \StructType\GuaranteeAccepted
     */
    public function setDefault($default = null)
    {
        // validation for constraint: boolean
        if (!is_null($default) && !is_bool($default)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($default, true), gettype($default)), __LINE__);
        }
        $this->Default = $default;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GuaranteeAccepted
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
