<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ItineraryItems StructType
 * @subpackage Structs
 */
class ItineraryItems extends AbstractStructBase
{
    /**
     * The ItineraryItem
     * Meta information extracted from the WSDL
     * - form: qualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ItineraryItem[]
     */
    public $ItineraryItem;
    /**
     * Constructor method for ItineraryItems
     * @uses ItineraryItems::setItineraryItem()
     * @param \StructType\ItineraryItem[] $itineraryItem
     */
    public function __construct(array $itineraryItem = array())
    {
        $this
            ->setItineraryItem($itineraryItem);
    }
    /**
     * Get ItineraryItem value
     * @return \StructType\ItineraryItem[]|null
     */
    public function getItineraryItem()
    {
        return $this->ItineraryItem;
    }
    /**
     * This method is responsible for validating the values passed to the setItineraryItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setItineraryItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateItineraryItemForArrayConstraintsFromSetItineraryItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $itineraryItemsItineraryItemItem) {
            // validation for constraint: itemType
            if (!$itineraryItemsItineraryItemItem instanceof \StructType\ItineraryItem) {
                $invalidValues[] = is_object($itineraryItemsItineraryItemItem) ? get_class($itineraryItemsItineraryItemItem) : sprintf('%s(%s)', gettype($itineraryItemsItineraryItemItem), var_export($itineraryItemsItineraryItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ItineraryItem property can only contain items of type \StructType\ItineraryItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ItineraryItem value
     * @throws \InvalidArgumentException
     * @param \StructType\ItineraryItem[] $itineraryItem
     * @return \StructType\ItineraryItems
     */
    public function setItineraryItem(array $itineraryItem = array())
    {
        // validation for constraint: array
        if ('' !== ($itineraryItemArrayErrorMessage = self::validateItineraryItemForArrayConstraintsFromSetItineraryItem($itineraryItem))) {
            throw new \InvalidArgumentException($itineraryItemArrayErrorMessage, __LINE__);
        }
        $this->ItineraryItem = $itineraryItem;
        return $this;
    }
    /**
     * Add item to ItineraryItem value
     * @throws \InvalidArgumentException
     * @param \StructType\ItineraryItem $item
     * @return \StructType\ItineraryItems
     */
    public function addToItineraryItem(\StructType\ItineraryItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ItineraryItem) {
            throw new \InvalidArgumentException(sprintf('The ItineraryItem property can only contain items of type \StructType\ItineraryItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ItineraryItem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ItineraryItems
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
