<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OTA_ResRetrieveRS StructType
 * Meta information extracted from the WSDL
 * - type: tns:OTA_ResRetrieveRS
 * @subpackage Structs
 */
class OTA_ResRetrieveRS extends AbstractStructBase
{
    /**
     * The Errors
     * Meta information extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * @var \StructType\Errors
     */
    public $Errors;
    /**
     * The POS
     * Meta information extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * @var \StructType\POS
     */
    public $POS;
    /**
     * The ReservationsList
     * Meta information extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * @var \StructType\ReservationList
     */
    public $ReservationsList;
    /**
     * The Success
     * Meta information extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * @var \StructType\Success
     */
    public $Success;
    /**
     * The Warnings
     * Meta information extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * @var \StructType\Warnings
     */
    public $Warnings;
    /**
     * The EchoToken
     * @var string
     */
    public $EchoToken;
    /**
     * The TimeStamp
     * @var string
     */
    public $TimeStamp;
    /**
     * The TransactionIdentifier
     * @var string
     */
    public $TransactionIdentifier;
    /**
     * Constructor method for OTA_ResRetrieveRS
     * @uses OTA_ResRetrieveRS::setErrors()
     * @uses OTA_ResRetrieveRS::setPOS()
     * @uses OTA_ResRetrieveRS::setReservationsList()
     * @uses OTA_ResRetrieveRS::setSuccess()
     * @uses OTA_ResRetrieveRS::setWarnings()
     * @uses OTA_ResRetrieveRS::setEchoToken()
     * @uses OTA_ResRetrieveRS::setTimeStamp()
     * @uses OTA_ResRetrieveRS::setTransactionIdentifier()
     * @param \StructType\Errors $errors
     * @param \StructType\POS $pOS
     * @param \StructType\ReservationList $reservationsList
     * @param \StructType\Success $success
     * @param \StructType\Warnings $warnings
     * @param string $echoToken
     * @param string $timeStamp
     * @param string $transactionIdentifier
     */
    public function __construct(\StructType\Errors $errors = null, \StructType\POS $pOS = null, \StructType\ReservationList $reservationsList = null, \StructType\Success $success = null, \StructType\Warnings $warnings = null, $echoToken = null, $timeStamp = null, $transactionIdentifier = null)
    {
        $this
            ->setErrors($errors)
            ->setPOS($pOS)
            ->setReservationsList($reservationsList)
            ->setSuccess($success)
            ->setWarnings($warnings)
            ->setEchoToken($echoToken)
            ->setTimeStamp($timeStamp)
            ->setTransactionIdentifier($transactionIdentifier);
    }
    /**
     * Get Errors value
     * @return \StructType\Errors|null
     */
    public function getErrors()
    {
        return $this->Errors;
    }
    /**
     * Set Errors value
     * @param \StructType\Errors $errors
     * @return \StructType\OTA_ResRetrieveRS
     */
    public function setErrors(\StructType\Errors $errors = null)
    {
        $this->Errors = $errors;
        return $this;
    }
    /**
     * Get POS value
     * @return \StructType\POS|null
     */
    public function getPOS()
    {
        return $this->POS;
    }
    /**
     * Set POS value
     * @param \StructType\POS $pOS
     * @return \StructType\OTA_ResRetrieveRS
     */
    public function setPOS(\StructType\POS $pOS = null)
    {
        $this->POS = $pOS;
        return $this;
    }
    /**
     * Get ReservationsList value
     * @return \StructType\ReservationList|null
     */
    public function getReservationsList()
    {
        return $this->ReservationsList;
    }
    /**
     * Set ReservationsList value
     * @param \StructType\ReservationList $reservationsList
     * @return \StructType\OTA_ResRetrieveRS
     */
    public function setReservationsList(\StructType\ReservationList $reservationsList = null)
    {
        $this->ReservationsList = $reservationsList;
        return $this;
    }
    /**
     * Get Success value
     * @return \StructType\Success|null
     */
    public function getSuccess()
    {
        return $this->Success;
    }
    /**
     * Set Success value
     * @param \StructType\Success $success
     * @return \StructType\OTA_ResRetrieveRS
     */
    public function setSuccess(\StructType\Success $success = null)
    {
        $this->Success = $success;
        return $this;
    }
    /**
     * Get Warnings value
     * @return \StructType\Warnings|null
     */
    public function getWarnings()
    {
        return $this->Warnings;
    }
    /**
     * Set Warnings value
     * @param \StructType\Warnings $warnings
     * @return \StructType\OTA_ResRetrieveRS
     */
    public function setWarnings(\StructType\Warnings $warnings = null)
    {
        $this->Warnings = $warnings;
        return $this;
    }
    /**
     * Get EchoToken value
     * @return string|null
     */
    public function getEchoToken()
    {
        return $this->EchoToken;
    }
    /**
     * Set EchoToken value
     * @param string $echoToken
     * @return \StructType\OTA_ResRetrieveRS
     */
    public function setEchoToken($echoToken = null)
    {
        // validation for constraint: string
        if (!is_null($echoToken) && !is_string($echoToken)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($echoToken, true), gettype($echoToken)), __LINE__);
        }
        $this->EchoToken = $echoToken;
        return $this;
    }
    /**
     * Get TimeStamp value
     * @return string|null
     */
    public function getTimeStamp()
    {
        return $this->TimeStamp;
    }
    /**
     * Set TimeStamp value
     * @param string $timeStamp
     * @return \StructType\OTA_ResRetrieveRS
     */
    public function setTimeStamp($timeStamp = null)
    {
        // validation for constraint: string
        if (!is_null($timeStamp) && !is_string($timeStamp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($timeStamp, true), gettype($timeStamp)), __LINE__);
        }
        $this->TimeStamp = $timeStamp;
        return $this;
    }
    /**
     * Get TransactionIdentifier value
     * @return string|null
     */
    public function getTransactionIdentifier()
    {
        return $this->TransactionIdentifier;
    }
    /**
     * Set TransactionIdentifier value
     * @param string $transactionIdentifier
     * @return \StructType\OTA_ResRetrieveRS
     */
    public function setTransactionIdentifier($transactionIdentifier = null)
    {
        // validation for constraint: string
        if (!is_null($transactionIdentifier) && !is_string($transactionIdentifier)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionIdentifier, true), gettype($transactionIdentifier)), __LINE__);
        }
        $this->TransactionIdentifier = $transactionIdentifier;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OTA_ResRetrieveRS
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
