<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Package StructType
 * @subpackage Structs
 */
class Package extends AbstractStructBase
{
    /**
     * The Cautions
     * Meta information extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * @var \StructType\Cautions
     */
    public $Cautions;
    /**
     * The DateRange
     * Meta information extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * @var \StructType\DateRange
     */
    public $DateRange;
    /**
     * The ItineraryItems
     * Meta information extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * @var \StructType\ItineraryItems
     */
    public $ItineraryItems;
    /**
     * The PriceInfo
     * Meta information extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * @var \StructType\PriceInfo
     */
    public $PriceInfo;
    /**
     * The Status
     * @var string
     */
    public $Status;
    /**
     * The ID
     * @var string
     */
    public $ID;
    /**
     * The Type
     * @var string
     */
    public $Type;
    /**
     * The PackageCode
     * @var string
     */
    public $PackageCode;
    /**
     * The TravelCode
     * @var string
     */
    public $TravelCode;
    /**
     * Constructor method for Package
     * @uses Package::setCautions()
     * @uses Package::setDateRange()
     * @uses Package::setItineraryItems()
     * @uses Package::setPriceInfo()
     * @uses Package::setStatus()
     * @uses Package::setID()
     * @uses Package::setType()
     * @uses Package::setPackageCode()
     * @uses Package::setTravelCode()
     * @param \StructType\Cautions $cautions
     * @param \StructType\DateRange $dateRange
     * @param \StructType\ItineraryItems $itineraryItems
     * @param \StructType\PriceInfo $priceInfo
     * @param string $status
     * @param string $iD
     * @param string $type
     * @param string $packageCode
     * @param string $travelCode
     */
    public function __construct(\StructType\Cautions $cautions = null, \StructType\DateRange $dateRange = null, \StructType\ItineraryItems $itineraryItems = null, \StructType\PriceInfo $priceInfo = null, $status = null, $iD = null, $type = null, $packageCode = null, $travelCode = null)
    {
        $this
            ->setCautions($cautions)
            ->setDateRange($dateRange)
            ->setItineraryItems($itineraryItems)
            ->setPriceInfo($priceInfo)
            ->setStatus($status)
            ->setID($iD)
            ->setType($type)
            ->setPackageCode($packageCode)
            ->setTravelCode($travelCode);
    }
    /**
     * Get Cautions value
     * @return \StructType\Cautions|null
     */
    public function getCautions()
    {
        return $this->Cautions;
    }
    /**
     * Set Cautions value
     * @param \StructType\Cautions $cautions
     * @return \StructType\Package
     */
    public function setCautions(\StructType\Cautions $cautions = null)
    {
        $this->Cautions = $cautions;
        return $this;
    }
    /**
     * Get DateRange value
     * @return \StructType\DateRange|null
     */
    public function getDateRange()
    {
        return $this->DateRange;
    }
    /**
     * Set DateRange value
     * @param \StructType\DateRange $dateRange
     * @return \StructType\Package
     */
    public function setDateRange(\StructType\DateRange $dateRange = null)
    {
        $this->DateRange = $dateRange;
        return $this;
    }
    /**
     * Get ItineraryItems value
     * @return \StructType\ItineraryItems|null
     */
    public function getItineraryItems()
    {
        return $this->ItineraryItems;
    }
    /**
     * Set ItineraryItems value
     * @param \StructType\ItineraryItems $itineraryItems
     * @return \StructType\Package
     */
    public function setItineraryItems(\StructType\ItineraryItems $itineraryItems = null)
    {
        $this->ItineraryItems = $itineraryItems;
        return $this;
    }
    /**
     * Get PriceInfo value
     * @return \StructType\PriceInfo|null
     */
    public function getPriceInfo()
    {
        return $this->PriceInfo;
    }
    /**
     * Set PriceInfo value
     * @param \StructType\PriceInfo $priceInfo
     * @return \StructType\Package
     */
    public function setPriceInfo(\StructType\PriceInfo $priceInfo = null)
    {
        $this->PriceInfo = $priceInfo;
        return $this;
    }
    /**
     * Get Status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->Status;
    }
    /**
     * Set Status value
     * @param string $status
     * @return \StructType\Package
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->Status = $status;
        return $this;
    }
    /**
     * Get ID value
     * @return string|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param string $iD
     * @return \StructType\Package
     */
    public function setID($iD = null)
    {
        // validation for constraint: string
        if (!is_null($iD) && !is_string($iD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iD, true), gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \StructType\Package
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get PackageCode value
     * @return string|null
     */
    public function getPackageCode()
    {
        return $this->PackageCode;
    }
    /**
     * Set PackageCode value
     * @param string $packageCode
     * @return \StructType\Package
     */
    public function setPackageCode($packageCode = null)
    {
        // validation for constraint: string
        if (!is_null($packageCode) && !is_string($packageCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($packageCode, true), gettype($packageCode)), __LINE__);
        }
        $this->PackageCode = $packageCode;
        return $this;
    }
    /**
     * Get TravelCode value
     * @return string|null
     */
    public function getTravelCode()
    {
        return $this->TravelCode;
    }
    /**
     * Set TravelCode value
     * @param string $travelCode
     * @return \StructType\Package
     */
    public function setTravelCode($travelCode = null)
    {
        // validation for constraint: string
        if (!is_null($travelCode) && !is_string($travelCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($travelCode, true), gettype($travelCode)), __LINE__);
        }
        $this->TravelCode = $travelCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Package
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
