<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PackageReservation StructType
 * Meta information extracted from the WSDL
 * - type: tns:PackageReservation
 * @subpackage Structs
 */
class PackageReservation extends AbstractStructBase
{
    /**
     * The InvoiceDetail
     * Meta information extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * @var \StructType\InvoiceDetail
     */
    public $InvoiceDetail;
    /**
     * The PassengerListItems
     * Meta information extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * @var \StructType\PassengerListItems
     */
    public $PassengerListItems;
    /**
     * The POS
     * Meta information extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * @var \StructType\POS
     */
    public $POS;
    /**
     * The Package
     * Meta information extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * @var \StructType\Package
     */
    public $Package;
    /**
     * The total
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Total
     */
    public $total;
    /**
     * The Transactions
     * Meta information extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * @var \StructType\Transactions
     */
    public $Transactions;
    /**
     * The UniqueID
     * Meta information extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * @var \StructType\UniqueID
     */
    public $UniqueID;
    /**
     * Constructor method for PackageReservation
     * @uses PackageReservation::setInvoiceDetail()
     * @uses PackageReservation::setPassengerListItems()
     * @uses PackageReservation::setPOS()
     * @uses PackageReservation::setPackage()
     * @uses PackageReservation::setTotal()
     * @uses PackageReservation::setTransactions()
     * @uses PackageReservation::setUniqueID()
     * @param \StructType\InvoiceDetail $invoiceDetail
     * @param \StructType\PassengerListItems $passengerListItems
     * @param \StructType\POS $pOS
     * @param \StructType\Package $package
     * @param \StructType\Total $total
     * @param \StructType\Transactions $transactions
     * @param \StructType\UniqueID $uniqueID
     */
    public function __construct(\StructType\InvoiceDetail $invoiceDetail = null, \StructType\PassengerListItems $passengerListItems = null, \StructType\POS $pOS = null, \StructType\Package $package = null, \StructType\Total $total = null, \StructType\Transactions $transactions = null, \StructType\UniqueID $uniqueID = null)
    {
        $this
            ->setInvoiceDetail($invoiceDetail)
            ->setPassengerListItems($passengerListItems)
            ->setPOS($pOS)
            ->setPackage($package)
            ->setTotal($total)
            ->setTransactions($transactions)
            ->setUniqueID($uniqueID);
    }
    /**
     * Get InvoiceDetail value
     * @return \StructType\InvoiceDetail|null
     */
    public function getInvoiceDetail()
    {
        return $this->InvoiceDetail;
    }
    /**
     * Set InvoiceDetail value
     * @param \StructType\InvoiceDetail $invoiceDetail
     * @return \StructType\PackageReservation
     */
    public function setInvoiceDetail(\StructType\InvoiceDetail $invoiceDetail = null)
    {
        $this->InvoiceDetail = $invoiceDetail;
        return $this;
    }
    /**
     * Get PassengerListItems value
     * @return \StructType\PassengerListItems|null
     */
    public function getPassengerListItems()
    {
        return $this->PassengerListItems;
    }
    /**
     * Set PassengerListItems value
     * @param \StructType\PassengerListItems $passengerListItems
     * @return \StructType\PackageReservation
     */
    public function setPassengerListItems(\StructType\PassengerListItems $passengerListItems = null)
    {
        $this->PassengerListItems = $passengerListItems;
        return $this;
    }
    /**
     * Get POS value
     * @return \StructType\POS|null
     */
    public function getPOS()
    {
        return $this->POS;
    }
    /**
     * Set POS value
     * @param \StructType\POS $pOS
     * @return \StructType\PackageReservation
     */
    public function setPOS(\StructType\POS $pOS = null)
    {
        $this->POS = $pOS;
        return $this;
    }
    /**
     * Get Package value
     * @return \StructType\Package|null
     */
    public function getPackage()
    {
        return $this->Package;
    }
    /**
     * Set Package value
     * @param \StructType\Package $package
     * @return \StructType\PackageReservation
     */
    public function setPackage(\StructType\Package $package = null)
    {
        $this->Package = $package;
        return $this;
    }
    /**
     * Get total value
     * @return \StructType\Total|null
     */
    public function getTotal()
    {
        return $this->total;
    }
    /**
     * Set total value
     * @param \StructType\Total $total
     * @return \StructType\PackageReservation
     */
    public function setTotal(\StructType\Total $total = null)
    {
        $this->total = $total;
        return $this;
    }
    /**
     * Get Transactions value
     * @return \StructType\Transactions|null
     */
    public function getTransactions()
    {
        return $this->Transactions;
    }
    /**
     * Set Transactions value
     * @param \StructType\Transactions $transactions
     * @return \StructType\PackageReservation
     */
    public function setTransactions(\StructType\Transactions $transactions = null)
    {
        $this->Transactions = $transactions;
        return $this;
    }
    /**
     * Get UniqueID value
     * @return \StructType\UniqueID|null
     */
    public function getUniqueID()
    {
        return $this->UniqueID;
    }
    /**
     * Set UniqueID value
     * @param \StructType\UniqueID $uniqueID
     * @return \StructType\PackageReservation
     */
    public function setUniqueID(\StructType\UniqueID $uniqueID = null)
    {
        $this->UniqueID = $uniqueID;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PackageReservation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
