<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PassengerRPHs StructType
 * @subpackage Structs
 */
class PassengerRPHs extends AbstractStructBase
{
    /**
     * The PassengerRPH
     * Meta information extracted from the WSDL
     * - form: qualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PassengerRPH[]
     */
    public $PassengerRPH;
    /**
     * Constructor method for PassengerRPHs
     * @uses PassengerRPHs::setPassengerRPH()
     * @param \StructType\PassengerRPH[] $passengerRPH
     */
    public function __construct(array $passengerRPH = array())
    {
        $this
            ->setPassengerRPH($passengerRPH);
    }
    /**
     * Get PassengerRPH value
     * @return \StructType\PassengerRPH[]|null
     */
    public function getPassengerRPH()
    {
        return $this->PassengerRPH;
    }
    /**
     * This method is responsible for validating the values passed to the setPassengerRPH method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPassengerRPH method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePassengerRPHForArrayConstraintsFromSetPassengerRPH(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $passengerRPHsPassengerRPHItem) {
            // validation for constraint: itemType
            if (!$passengerRPHsPassengerRPHItem instanceof \StructType\PassengerRPH) {
                $invalidValues[] = is_object($passengerRPHsPassengerRPHItem) ? get_class($passengerRPHsPassengerRPHItem) : sprintf('%s(%s)', gettype($passengerRPHsPassengerRPHItem), var_export($passengerRPHsPassengerRPHItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PassengerRPH property can only contain items of type \StructType\PassengerRPH, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PassengerRPH value
     * @throws \InvalidArgumentException
     * @param \StructType\PassengerRPH[] $passengerRPH
     * @return \StructType\PassengerRPHs
     */
    public function setPassengerRPH(array $passengerRPH = array())
    {
        // validation for constraint: array
        if ('' !== ($passengerRPHArrayErrorMessage = self::validatePassengerRPHForArrayConstraintsFromSetPassengerRPH($passengerRPH))) {
            throw new \InvalidArgumentException($passengerRPHArrayErrorMessage, __LINE__);
        }
        $this->PassengerRPH = $passengerRPH;
        return $this;
    }
    /**
     * Add item to PassengerRPH value
     * @throws \InvalidArgumentException
     * @param \StructType\PassengerRPH $item
     * @return \StructType\PassengerRPHs
     */
    public function addToPassengerRPH(\StructType\PassengerRPH $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PassengerRPH) {
            throw new \InvalidArgumentException(sprintf('The PassengerRPH property can only contain items of type \StructType\PassengerRPH, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PassengerRPH[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PassengerRPHs
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
