<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReadRequests StructType
 * @subpackage Structs
 */
class ReadRequests extends AbstractStructBase
{
    /**
     * The ReadRequest
     * Meta information extracted from the WSDL
     * - form: qualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ReadRequest[]
     */
    public $ReadRequest;
    /**
     * Constructor method for ReadRequests
     * @uses ReadRequests::setReadRequest()
     * @param \StructType\ReadRequest[] $readRequest
     */
    public function __construct(array $readRequest = array())
    {
        $this
            ->setReadRequest($readRequest);
    }
    /**
     * Get ReadRequest value
     * @return \StructType\ReadRequest[]|null
     */
    public function getReadRequest()
    {
        return $this->ReadRequest;
    }
    /**
     * This method is responsible for validating the values passed to the setReadRequest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setReadRequest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateReadRequestForArrayConstraintsFromSetReadRequest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $readRequestsReadRequestItem) {
            // validation for constraint: itemType
            if (!$readRequestsReadRequestItem instanceof \StructType\ReadRequest) {
                $invalidValues[] = is_object($readRequestsReadRequestItem) ? get_class($readRequestsReadRequestItem) : sprintf('%s(%s)', gettype($readRequestsReadRequestItem), var_export($readRequestsReadRequestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ReadRequest property can only contain items of type \StructType\ReadRequest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ReadRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\ReadRequest[] $readRequest
     * @return \StructType\ReadRequests
     */
    public function setReadRequest(array $readRequest = array())
    {
        // validation for constraint: array
        if ('' !== ($readRequestArrayErrorMessage = self::validateReadRequestForArrayConstraintsFromSetReadRequest($readRequest))) {
            throw new \InvalidArgumentException($readRequestArrayErrorMessage, __LINE__);
        }
        $this->ReadRequest = $readRequest;
        return $this;
    }
    /**
     * Add item to ReadRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\ReadRequest $item
     * @return \StructType\ReadRequests
     */
    public function addToReadRequest(\StructType\ReadRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ReadRequest) {
            throw new \InvalidArgumentException(sprintf('The ReadRequest property can only contain items of type \StructType\ReadRequest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ReadRequest[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ReadRequests
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
