<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ResGuests StructType
 * @subpackage Structs
 */
class ResGuests extends AbstractStructBase
{
    /**
     * The ResGuest
     * Meta information extracted from the WSDL
     * - form: qualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ResGuest[]
     */
    public $ResGuest;
    /**
     * Constructor method for ResGuests
     * @uses ResGuests::setResGuest()
     * @param \StructType\ResGuest[] $resGuest
     */
    public function __construct(array $resGuest = array())
    {
        $this
            ->setResGuest($resGuest);
    }
    /**
     * Get ResGuest value
     * @return \StructType\ResGuest[]|null
     */
    public function getResGuest()
    {
        return $this->ResGuest;
    }
    /**
     * This method is responsible for validating the values passed to the setResGuest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setResGuest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateResGuestForArrayConstraintsFromSetResGuest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $resGuestsResGuestItem) {
            // validation for constraint: itemType
            if (!$resGuestsResGuestItem instanceof \StructType\ResGuest) {
                $invalidValues[] = is_object($resGuestsResGuestItem) ? get_class($resGuestsResGuestItem) : sprintf('%s(%s)', gettype($resGuestsResGuestItem), var_export($resGuestsResGuestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ResGuest property can only contain items of type \StructType\ResGuest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ResGuest value
     * @throws \InvalidArgumentException
     * @param \StructType\ResGuest[] $resGuest
     * @return \StructType\ResGuests
     */
    public function setResGuest(array $resGuest = array())
    {
        // validation for constraint: array
        if ('' !== ($resGuestArrayErrorMessage = self::validateResGuestForArrayConstraintsFromSetResGuest($resGuest))) {
            throw new \InvalidArgumentException($resGuestArrayErrorMessage, __LINE__);
        }
        $this->ResGuest = $resGuest;
        return $this;
    }
    /**
     * Add item to ResGuest value
     * @throws \InvalidArgumentException
     * @param \StructType\ResGuest $item
     * @return \StructType\ResGuests
     */
    public function addToResGuest(\StructType\ResGuest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ResGuest) {
            throw new \InvalidArgumentException(sprintf('The ResGuest property can only contain items of type \StructType\ResGuest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ResGuest[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ResGuests
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
