<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TPA_Extensions StructType
 * @subpackage Structs
 */
class TPA_Extensions extends AbstractStructBase
{
    /**
     * The TPA_Extension
     * Meta information extracted from the WSDL
     * - form: qualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\TpaExtension[]
     */
    public $TPA_Extension;
    /**
     * Constructor method for TPA_Extensions
     * @uses TPA_Extensions::setTPA_Extension()
     * @param \StructType\TpaExtension[] $tPA_Extension
     */
    public function __construct(array $tPA_Extension = array())
    {
        $this
            ->setTPA_Extension($tPA_Extension);
    }
    /**
     * Get TPA_Extension value
     * @return \StructType\TpaExtension[]|null
     */
    public function getTPA_Extension()
    {
        return $this->TPA_Extension;
    }
    /**
     * This method is responsible for validating the values passed to the setTPA_Extension method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTPA_Extension method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTPA_ExtensionForArrayConstraintsFromSetTPA_Extension(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $tPA_ExtensionsTPA_ExtensionItem) {
            // validation for constraint: itemType
            if (!$tPA_ExtensionsTPA_ExtensionItem instanceof \StructType\TpaExtension) {
                $invalidValues[] = is_object($tPA_ExtensionsTPA_ExtensionItem) ? get_class($tPA_ExtensionsTPA_ExtensionItem) : sprintf('%s(%s)', gettype($tPA_ExtensionsTPA_ExtensionItem), var_export($tPA_ExtensionsTPA_ExtensionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TPA_Extension property can only contain items of type \StructType\TpaExtension, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TPA_Extension value
     * @throws \InvalidArgumentException
     * @param \StructType\TpaExtension[] $tPA_Extension
     * @return \StructType\TPA_Extensions
     */
    public function setTPA_Extension(array $tPA_Extension = array())
    {
        // validation for constraint: array
        if ('' !== ($tPA_ExtensionArrayErrorMessage = self::validateTPA_ExtensionForArrayConstraintsFromSetTPA_Extension($tPA_Extension))) {
            throw new \InvalidArgumentException($tPA_ExtensionArrayErrorMessage, __LINE__);
        }
        $this->TPA_Extension = $tPA_Extension;
        return $this;
    }
    /**
     * Add item to TPA_Extension value
     * @throws \InvalidArgumentException
     * @param \StructType\TpaExtension $item
     * @return \StructType\TPA_Extensions
     */
    public function addToTPA_Extension(\StructType\TpaExtension $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TpaExtension) {
            throw new \InvalidArgumentException(sprintf('The TPA_Extension property can only contain items of type \StructType\TpaExtension, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TPA_Extension[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TPA_Extensions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
